      function maxvec3 ( vec, nxa, nya, nza, 
     .  sl1, sl2, sl3, sl4, sl5, sl6)
c ======================================================================
c
c
c        programmer     Jos van Kan
c        version 1.0    date   10-03-97
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c   pilotcode 3d mgpackage
c
c ********************************************************************
c
c                         DESCRIPTION
c
c ********************************************************************
c
c                      KEYWORDS
c
c ********************************************************************
c
c         MODULES USED
c
      use mgpreset
c
c **********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
      double precision maxvec3
      integer sl1, sl2, sl3, sl4, sl5, sl6
      integer nxa, nya , nza
      double precision 
     . vec (1-sl1:nxa+sl2, 1-sl3:nya+sl4,
     . 1-sl5:nza+sl6)

c   nxa             number of grid x points on this level
c   nya             number of grid y points on this level
c   nza             number of grid z points on this level
c   vec             generic name for quantity with the dimension of
c                   sol or rhs
c	sl1	i    Slack variable, x lower bound
c	sl2	i    Slack variable, x upper bound
c	sl3	i    Slack variable, y lower bound
c	sl4	i    Slack variable, y upper bound
c	sl5	i    Slack variable, z lower bound
c	sl6	i    Slack variable, z upper bound
c		    zhi)
c
c ********************************************************************
c
c                      COMMON BLOCKS
c
c ********************************************************************
c
c                      LOCAL PARAMETERS
      integer ixa, iya, iza
      double precision currentmax
c
c   currentmax      current calculated maximum
c   ixa             counter to number of grid x points on this level
c   iya             counter to number of grid y points on this level
c
c ********************************************************************
c
c                      SUBROUTINES CALLED
c
c     
c ********************************************************************
c
c                      I/O
c
c ********************************************************************
c
c                      ERROR MESSAGES
c
c ********************************************************************
c
c                      PSEUDO CODE
c
c ======================================================================
      currentmax = 0d0
      do iza = 1, nza
        do iya = 1, nya
          do ixa = 1, nxa
          if (abs (vec (ixa, iya, iza)) .gt. currentmax) then
             currentmax = abs (vec (ixa, iya, iza))
          endif
          end do
        end do
      end do
      maxvec3 = currentmax
      end
