      subroutine printblock3 ( block, nx, ny, nz, 
     .  sl1, sl2, sl3, sl4, sl5, sl6)
     
c ======================================================================
c
c
c        programmer     Jos van Kan
c        version 1.0    date   12-03-97
c
c   copyright (c) 1997
c   all rights reserved. no part of this publication may be reproduced,
c   stored in a retrieval system ( e.g., in memory, disk, or core)
c   or be transmitted by any means, electronic, mechanical, photocopy,
c   recording, or otherwise, without written permission from the
c   author.
c
c   pilotcode 3d mgpackage
c
c ********************************************************************
c
c                         DESCRIPTION
c
c  a matrix consisting of a 3-point stencil on a nx * ny * nz grid is printed
c  per ROW of the grid, one stencil per line, one plane per block
c   It is assumed that the matrix has dimension (nx, ny, nz, 3)
c
c
c ********************************************************************
c
c                      KEYWORDS
c
c ********************************************************************
c
c         MODULES USED
c
      use mgpreset
c
c **********************************************************************
c
c                      INPUT / OUTPUT    PARAMETERS
c
      implicit none
      integer sl1, sl2, sl3, sl4, sl5, sl6
      integer nx, ny, nz
      double precision 
     .block(1-sl1:nx+sl2,1-sl3:ny+sl4,
     . 1-sl5:nz+sl6,3)
c
c   block           the nx*ny*3 diagonal blockmatrix used in line jacobi
c   nx              number of grid x points on finest grid
c   ny              number of grid y points on finest grid
c   nz              number of grid z points on finest grid
c	sl1	i    Slack variable, x lower bound
c	sl2	i    Slack variable, x upper bound
c	sl3	i    Slack variable, y lower bound
c	sl4	i    Slack variable, y upper bound
c	sl5	i    Slack variable, z lower bound
c	sl6	i    Slack variable, z upper bound
c		    zhi)
c
c ********************************************************************
c
c                      COMMON BLOCKS
c
c
c ********************************************************************
c
c                      LOCAL PARAMETERS
      integer ix, iy, iz
c
c   ix              counter to number of grid x points on finest grid
c   iy              counter to number of grid y points on finest grid
c   iz              counter to number of grid z points on finest grid
c
c ********************************************************************
c
c                      SUBROUTINES CALLED
c
c     
c ********************************************************************
c
c                      I/O
c
c ********************************************************************
c
c                      ERROR MESSAGES
c
c ********************************************************************
c
c                      PSEUDO CODE
c
c ======================================================================
      write (*, *) 'Print tridiagonal block output. '
      do iz = 1, nz
      write (*, *) 'Plane: ', iz
      do iy = 1, ny
         do ix = 1, nx
           write (*, 100) 
     .block (ix,iy,iz,SUB),block (ix,iy,iz,DIAG),block (ix,iy,iz,SUP) 
         end do
         write (*, '(1X)')
      end do
      write (*, '(1X)')
      end do
100   format (3f16.8)
      end
